


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html id="htmlId">
<head>
  <title>Coverage Report :: UserAccessService</title>
  <style type="text/css">
    @import "../../.css/coverage.css";
  </style>
</head>

<body>
<div class="header"></div>

<div class="content">
<div class="breadCrumbs">
    [ <a href="../../index.html">all classes</a> ]
    [ <a href="../index.html">com.dema.timeregistration.service</a> ]
</div>

<h1>Coverage Summary for Class: UserAccessService (com.dema.timeregistration.service)</h1>

<table class="coverageStats">
<tr>
  <th class="name">Class</th>
<th class="coverageStat 
">
  Class, %
</th>
<th class="coverageStat 
">
  Method, %
</th>
<th class="coverageStat 
">
  Line, %
</th>
</tr>
<tr>
  <td class="name">UserAccessService</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (1/ 1)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (5/ 5)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    95.5%
  </span>
  <span class="absValue">
    (21/ 22)
  </span>
</td>
</tr>

</table>

<br/>
<br/>


<div class="sourceCode"><i>1</i>&nbsp;package com.dema.timeregistration.service;
<i>2</i>&nbsp;
<i>3</i>&nbsp;import com.dema.timeregistration.entity.GlobalRole;
<i>4</i>&nbsp;import com.dema.timeregistration.entity.Project;
<i>5</i>&nbsp;import com.dema.timeregistration.entity.ProjectRole;
<i>6</i>&nbsp;import com.dema.timeregistration.entity.User;
<i>7</i>&nbsp;import com.dema.timeregistration.entity.*;
<i>8</i>&nbsp;import com.dema.timeregistration.repository.UserRepository;
<i>9</i>&nbsp;import com.dema.timeregistration.service.exception.AccessDeniedException;
<i>10</i>&nbsp;import com.dema.timeregistration.service.exception.EntityNotFoundException;
<i>11</i>&nbsp;
<i>12</i>&nbsp;import java.util.Optional;
<i>13</i>&nbsp;
<i>14</i>&nbsp;import java.util.Set;
<i>15</i>&nbsp;
<i>16</i>&nbsp;public class UserAccessService {
<i>17</i>&nbsp;    private final UserRepository userRepository;
<i>18</i>&nbsp;
<b class="fc"><i>19</i>&nbsp;    public UserAccessService(UserRepository userRepository) {</b>
<b class="fc"><i>20</i>&nbsp;        this.userRepository = userRepository;</b>
<b class="fc"><i>21</i>&nbsp;    }</b>
<i>22</i>&nbsp;
<i>23</i>&nbsp;    public boolean isUserGlobalAdmin(int userId) throws EntityNotFoundException {
<b class="fc"><i>24</i>&nbsp;        User user = userRepository.findById(userId).orElseThrow(EntityNotFoundException::userNotFound);</b>
<b class="fc"><i>25</i>&nbsp;        return user.getGlobalRole().equals(GlobalRole.GLOBAL_ADMINISTRATOR);</b>
<i>26</i>&nbsp;    }
<i>27</i>&nbsp;
<i>28</i>&nbsp;    public void throwIfUserIsNotAdmin(UserContext userContext) throws EntityNotFoundException, AccessDeniedException {
<b class="fc"><i>29</i>&nbsp;        if (!isUserGlobalAdmin(userContext.getUser().getId())) {</b>
<b class="fc"><i>30</i>&nbsp;            throw AccessDeniedException.requiresAdministratorRole();</b>
<i>31</i>&nbsp;        }
<b class="fc"><i>32</i>&nbsp;    }</b>
<i>33</i>&nbsp;
<i>34</i>&nbsp;    public void throwIfUserIsNotProjectLeaderOrAdmin(Project project, UserContext userContext) throws AccessDeniedException {
<b class="fc"><i>35</i>&nbsp;        Optional&lt;ProjectRole&gt; projectRoleOptional = userContext.getUser().getProjectRoles()</b>
<b class="fc"><i>36</i>&nbsp;                .stream()</b>
<b class="fc"><i>37</i>&nbsp;                .filter(pr -&gt; pr.getProject().equals(project) &amp;&amp; pr.getRole().equals(Role.PROJECT_LEADER))</b>
<b class="fc"><i>38</i>&nbsp;                .findFirst();</b>
<i>39</i>&nbsp;
<b class="fc"><i>40</i>&nbsp;        if (!projectRoleOptional.isPresent() &amp;&amp; !userContext.getUser().getGlobalRole().equals(GlobalRole.GLOBAL_ADMINISTRATOR)) {</b>
<b class="fc"><i>41</i>&nbsp;            throw AccessDeniedException.projectLeaderOrAdministratorRole();</b>
<i>42</i>&nbsp;        }
<b class="fc"><i>43</i>&nbsp;    }</b>
<i>44</i>&nbsp;
<i>45</i>&nbsp;    public void throwIfUserDoesNotHaveProjectRole(Project project, UserContext userContext) throws AccessDeniedException {
<b class="fc"><i>46</i>&nbsp;        Optional&lt;ProjectRole&gt; projectRoleOptional = userContext.getUser().getProjectRoles()</b>
<b class="fc"><i>47</i>&nbsp;                .stream()</b>
<b class="fc"><i>48</i>&nbsp;                .filter(pr -&gt; pr.getProject().equals(project))</b>
<b class="fc"><i>49</i>&nbsp;                .findFirst();</b>
<i>50</i>&nbsp;
<b class="fc"><i>51</i>&nbsp;        if (!projectRoleOptional.isPresent() &amp;&amp; !userContext.getUser().getGlobalRole().equals(GlobalRole.GLOBAL_ADMINISTRATOR)) {</b>
<b class="nc"><i>52</i>&nbsp;            throw AccessDeniedException.projectRoleOrAdministratorRole();</b>
<i>53</i>&nbsp;        }
<b class="fc"><i>54</i>&nbsp;    }</b>
<i>55</i>&nbsp;}
</div>
</div>

<div class="footer">
    
    <div style="float:right;">generated on 2019-05-13 13:51</div>
</div>
</body>
</html>
